
/* Ensures new hotfix field in settings */
DECLARE @settingid int
SET @settingid = ISNULL((SELECT KeyID FROM CMS_SettingsKey WHERE KeyName = N'CMSHotfixVersion'), 0)

IF (@settingid = 0) BEGIN

INSERT INTO [CMS_SettingsKey]
           ([KeyName]
           ,[KeyDisplayName]
           ,[KeyDescription]
           ,[KeyValue]
           ,[KeyType]
           ,[KeyCategoryID]
           ,[SiteID]
           ,[KeyGUID]
           ,[KeyLastModified]
           ,[KeyOrder]
           ,[KeyDefaultValue]
           ,[KeyValidation]
           ,[KeyEditingControlPath]
           ,[KeyLoadGeneration]
           ,[KeyIsGlobal])
     VALUES
           ('CMSHotfixVersion'
           ,'Hotfix version'
           ,'Hotfix version'
           ,'0'
           ,'int'
           ,NULL
           ,NULL
           ,newId()
           ,getDate()
           ,NULL
           ,'0'
           ,NULL
           ,NULL
           ,0
           ,1)
END
GO


UPDATE CMS_Query
SET QueryText = 
'SELECT ##TOPN##  IsSecuredNode, DocumentStylesheetID, DocumentPageTemplateID, NodeDocType, NodeHeadTags, NodeCacheMinutes, DocumentPageTitle, DocumentPageKeyWords, DocumentPageDescription, NodeBodyElementAttributes, RequiresSSL, NodeID, DocumentID, DocumentCulture, NodeACLID, NodeLinkedNodeID, ClassName, NodeAliasPath FROM View_CMS_Tree_Joined WHERE ##WHERE## ORDER BY ##ORDERBY##' WHERE QueryName = 'selectuppertree' AND ClassID = (SELECT ClassID FROM CMS_Class WHERE ClassName=N'CMS.Document')
GO

-- Inserting Resource strings
DECLARE @stringId AS int;
DECLARE @cultureId AS int;
DECLARE @cultureCode AS nvarchar(50);

-- Change value of this parameter if your default UI culture is not 'en-US' (see details in hotfix instructions)
SET @cultureCode = 'en-US';

-- Get culture ID
SET @cultureID = (SELECT UICultureID FROM [CMS_UICulture] WHERE UICultureCode=@cultureCode);

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'UserControlSelector.RequireFileName' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('UserControlSelector.RequireFileName'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Please enter some file name.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'TemplateDesigner.ErrorExistingColumnInJoinedTable' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('TemplateDesigner.ErrorExistingColumnInJoinedTable'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Column name already exists in some table, which is joined to this table in order to create a view.  Please enter some other name.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'UserControlSelector.RequireFolderName' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('UserControlSelector.RequireFolderName'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Please enter some folder name.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'dialogs.filesystem.ExcludedExtension' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('dialogs.filesystem.ExcludedExtension'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Entered file name extension is in list of excluded extensions: %%extensions%%, please enter filename with other extension.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'workflowproperties.scopenotset' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('workflowproperties.scopenotset'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'The document is not configured to use workflow and versioning.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'dialogs.filesystem.NotAllowedExtension' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('dialogs.filesystem.NotAllowedExtension'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Please enter a file name with an allowed extension. Allowed extensions: %%extensions%%.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'dialogs.filesystem.NotAllowedFolder' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('dialogs.filesystem.NotAllowedFolder'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Entered folder name path or its part is not allowed.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'importconfiguration.securityerror' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('importconfiguration.securityerror'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Unable to get list of import packages due to insufficient permissions for the ''{0}'' folder.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'attach.loading' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('attach.loading'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Uploading &#46;&#46;&#46;')
END
ELSE
	UPDATE [CMS_ResourceTranslation] SET [TranslationText] = 'Uploading &#46;&#46;&#46;'
    WHERE [TranslationStringID] = @stringId AND [TranslationUICultureID] = @cultureId


-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'Recyclebin.RestorationFailedPermissions' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('Recyclebin.RestorationFailedPermissions'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Document ''{0}'' could not be restored because you don''t have ''Create'' permission.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'recyclebin.destructionfailedpermissions' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('recyclebin.destructionfailedpermissions'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Document ''{0}'' could not be destroyed because you don''t have the ''Destroy'' permission.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'recyclebin.errorsomenotrestored' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('recyclebin.errorsomenotrestored'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Some of the documents couldn''t be restored as you do not have ''Create'' permission.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'recyclebin.errorsomenotdestroyed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('recyclebin.errorsomenotdestroyed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Destroying document(s) failed<br /> Some of the documents couldn''t be destroyed as you do not have ''Destroy'' permission.')
END
ELSE
	UPDATE [CMS_ResourceTranslation] SET [TranslationText] = 'Destroying document(s) failed<br /> Some of the documents couldn''t be destroyed as you do not have ''Destroy'' permission.'
    WHERE [TranslationStringID] = @stringId AND [TranslationUICultureID] = @cultureId

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'objecttasks.newsletter_usersubscriber' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('objecttasks.newsletter_usersubscriber'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'User subscribers')
END


-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'objecttasks.newsletter_rolesubscriber' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('objecttasks.newsletter_rolesubscriber'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Role subscribers')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'objecttasks.newsletter_subscriber' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('objecttasks.newsletter_subscriber'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Standard subscribers')
END
ELSE
	UPDATE [CMS_ResourceTranslation] SET [TranslationText] = 'Standard subscribers'
    WHERE [TranslationStringID] = @stringId AND [TranslationUICultureID] = @cultureId

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'objecttype.newsletter_subscriber' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('objecttype.newsletter_subscriber'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Newsletter standard subscriber')
END
ELSE
	UPDATE [CMS_ResourceTranslation] SET [TranslationText] = 'Newsletter standard subscriber'
    WHERE [TranslationStringID] = @stringId AND [TranslationUICultureID] = @cultureId

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'objecttype.newsletter_usersubscriber' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('objecttype.newsletter_usersubscriber'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Newsletter user subscriber')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'objecttype.newsletter_rolesubscriber' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('objecttype.newsletter_rolesubscriber'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Newsletter role subscriber')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'objecttasks.__subscribers__' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('objecttasks.__subscribers__'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Subscribers')
END

-- Check if resource string general.badhashtitle exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'general.badhashtitle' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('general.badhashtitle'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to load page parameters')
END

-- Check if resource string general.badhashtex exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'general.badhashtext' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('general.badhashtext'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'The page parameters are not consistent, please try to reopen the page.')
END


-- Check if resource string general.badhashtex exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'dialogs.advanced.flashvars' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('dialogs.advanced.flashvars'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Flash vars')
END


-- Check if resource string sharepoint.DataBindError exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'sharepoint.databinderror' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('sharepoint.databinderror'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Data binding failed with following error: {0}')
END

GO


-- Insert new DeleteArchived query 
DECLARE @classID int
SET @classID = (SELECT ClassID FROM CMS_Class WHERE ClassName LIKE 'cms.email')

IF  (SELECT TOP 1 QueryName FROM [CMS_Query] WHERE ClassID = @classID AND QueryName LIKE 'deletearchived') IS NULL
BEGIN

	INSERT INTO [CMS_Query]
				(
				[QueryName],
				[QueryTypeID],
				[QueryText],
				[QueryRequiresTransaction],
				[ClassID],
				[QueryIsLocked],
				[QueryLastModified],
				[QueryGUID],
				[QueryLoadGeneration]
				)
		  VALUES
				(
				 'deletearchived',
				 1,
				 'Proc_CMS_Email_DeleteArchived',
				 0,
				 @classID,
				 1,
				 getDate(),
				 newId(),
				 2
				)
END				
GO

-- Check if Stored Procedure already exists
IF (SELECT TOP 1 Name FROM SysObjects WHERE Type = 'P' and Name='Proc_CMS_Email_DeleteArchived') IS NOT NULL
BEGIN
DROP PROCEDURE [Proc_CMS_Email_DeleteArchived]
END

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [Proc_CMS_Email_DeleteArchived]
	-- Procedure parameters
	@SiteID int	= 0,
	@ExpiryDate datetime,
	@EmailStatus int = 3
AS
BEGIN
SET NOCOUNT ON;
	-- Declare table for emails
	DECLARE @emails TABLE ( EmailID int not null ) 
	BEGIN
		-- Get global e-mails
		IF ((@SiteID = 0) OR (@SiteID IS NULL))
			INSERT INTO @emails 
				SELECT EmailID FROM CMS_Email 
				WHERE EmailLastSendAttempt <= @ExpiryDate
					AND (EmailSiteID IS NULL)
					AND EmailStatus = @EmailStatus
		-- Get all e-mails attached to the site			
		ELSE                   
			INSERT INTO @emails 
				SELECT EmailID FROM CMS_Email 
				WHERE EmailLastSendAttempt <= @ExpiryDate
					AND EmailSiteID = @SiteID
					AND EmailStatus = @EmailStatus
	END
      
	BEGIN TRANSACTION
          
	-- Delete attachment binding 
	DELETE FROM [CMS_AttachmentForEmail] WHERE EmailID IN (SELECT EmailID FROM @emails)
	-- Delete user binding
	DELETE FROM [CMS_EmailUser] WHERE EmailID IN (SELECT EmailID FROM @emails)
	-- Delete all attachments that have no bindings
	DELETE FROM CMS_EmailAttachment WHERE AttachmentID NOT IN (SELECT DISTINCT AttachmentID FROM CMS_AttachmentForEmail)
	-- Delete e-mails
	DELETE FROM [CMS_Email] WHERE EmailID IN (SELECT EmailID FROM @emails)
      
	COMMIT TRANSACTION;
END
GO



ALTER PROCEDURE [Proc_CMS_Document_UpdateDocumentNamePath]
	@OriginalNodeID int,
	@SiteID int,
	@DefaultCultureCode nvarchar(10)
AS
BEGIN
	/* Get all starting paths to process */
	DECLARE @nodesTable TABLE (
		NodeAliasPath nvarchar(450)
	);
	
	/* Get the nodes list */
	INSERT INTO @nodesTable SELECT NodeAliasPath FROM CMS_Tree WHERE NodeID = @OriginalNodeID OR NodeLinkedNodeID = @OriginalNodeID ORDER BY NodeAliasPath;
	/* Declare the cursor to loop through the table */
	DECLARE @nodeCursor CURSOR;
    SET @nodeCursor = CURSOR FOR SELECT NodeAliasPath FROM @nodesTable;
	
	DECLARE @startingAliasPath nvarchar(450)
	
	/* Loop through the table */
	OPEN @nodeCursor
	FETCH NEXT FROM @nodeCursor INTO @startingAliasPath;
	WHILE @@FETCH_STATUS = 0
	BEGIN
		/* Get the list of nodes to update */
		DECLARE @processDocuments TABLE (
				DocumentID int,
				NodeParentID int,
				DocumentCulture nvarchar(10),
				DocumentUseNamePathForUrlPath bit,
				DocumentUrlPath nvarchar(450)
		);

		INSERT INTO @processDocuments SELECT DocumentID, NodeParentID, DocumentCulture, DocumentUseNamePathForUrlPath, DocumentUrlPath FROM View_CMS_Tree_Joined WHERE NodeAliasPath LIKE @startingAliasPath + '/%' OR NodeAliasPath = @startingAliasPath AND NodeSiteID = @SiteID ORDER BY NodeLinkedNodeID DESC, NodeLevel ASC
		
		/* Loop through documents */
		DECLARE @documentId int;
		DECLARE @nodeParentId int;
		DECLARE @documentCulture nvarchar(10);
		DECLARE @useNamePathForUrlPath bit;
		DECLARE @documentUrlPath nvarchar(450);

		DECLARE @documentCursor CURSOR;
		SET @documentCursor = CURSOR FOR SELECT DocumentID, NodeParentID, DocumentCulture, DocumentUseNamePathForUrlPath, DocumentUrlPath FROM @processDocuments;
		
		OPEN @documentCursor
		FETCH NEXT FROM @documentCursor INTO @documentId, @nodeParentId, @documentCulture, @useNamePathForUrlPath, @documentUrlPath
		WHILE @@FETCH_STATUS = 0
		BEGIN
			/* Update the name path */
			DECLARE @parentNamePath nvarchar(1500);
			DECLARE @parentUseNamePathForUrlPath bit;
			DECLARE @parentUrlPath nvarchar(450);

			SELECT @parentNamePath = DocumentNamePath, @parentUseNamePathForUrlPath = DocumentUseNamePathForUrlPath, @parentUrlPath = DocumentUrlPath FROM
				(SELECT TOP 1 DocumentNamePath, DocumentUseNamePathForUrlPath, DocumentUrlPath FROM (
					(SELECT DocumentNamePath, DocumentUseNamePathForUrlPath, DocumentUrlPath, 1 AS Priority FROM View_CMS_Tree_Joined WHERE NodeID = @nodeParentId AND DocumentCulture = @documentCulture AND NodeAliasPath <> '/') UNION ALL 
					(SELECT DocumentNamePath, DocumentUseNamePathForUrlPath, DocumentUrlPath, 2 AS Priority FROM View_CMS_Tree_Joined WHERE NodeID = @nodeParentId AND DocumentCulture = @DefaultCultureCode AND NodeAliasPath <> '/') UNION ALL
					(SELECT DocumentNamePath, DocumentUseNamePathForUrlPath, DocumentUrlPath, 3 AS Priority FROM View_CMS_Tree_Joined WHERE NodeID = @nodeParentId AND NodeAliasPath <> '/') UNION ALL
					(SELECT '', 0, '', 4 AS Priority)
				) ParentPaths ORDER BY Priority ASC) TopParentPath;
		
			/* Update the URL path (parent URL path + last part of URL path */
			IF @useNamePathForUrlPath = 1 AND @parentUseNamePathForUrlPath = 1 AND @parentUrlPath <> '' AND  @documentUrlPath <> ''
			BEGIN
				SET @documentUrlPath = @parentUrlPath + '/' + RIGHT(@documentUrlPath, CHARINDEX('/', REVERSE(@documentUrlPath)) - 1);
			END;

			/* Update the document */
			UPDATE CMS_Document SET DocumentNamePath = @parentNamePath + '/' + DocumentName, DocumentUrlPath = @documentUrlPath WHERE DocumentID = @documentId
			
			FETCH NEXT FROM @documentCursor INTO @documentId, @nodeParentId, @documentCulture, @useNamePathForUrlPath, @documentUrlPath
		END

		CLOSE @documentCursor;
		DEALLOCATE @documentCursor;

		FETCH NEXT FROM @nodeCursor INTO @startingAliasPath;
	END
	CLOSE @nodeCursor;
	DEALLOCATE @nodeCursor;
END
GO

-- Insert stored procedure for ACLs
IF (SELECT TOP 1 Name FROM SysObjects WHERE Type = 'P' and Name='Proc_CMS_ACL_RemoveACLID') IS NOT NULL
BEGIN
DROP PROCEDURE [Proc_CMS_ACL_RemoveACLID]
END
GO

CREATE PROCEDURE [Proc_CMS_ACL_RemoveACLID]
	@ACLID nvarchar(450),
	@SiteID int, 
	@NodeAliasPath nvarchar(450)	
AS
BEGIN
	DECLARE @ACLInheritedACLs nvarchar(450);
	DECLARE @ACL int;
	DECLARE @InheritedACLsLength int;
	DECLARE @aclCursor CURSOR;
	
	SET @aclCursor = CURSOR FOR SELECT ACLInheritedACLs,ACLID FROM CMS_ACL WHERE CMS_ACL.ACLID IN (SELECT DISTINCT		CMS_Tree.NodeACLID FROM CMS_Tree INNER JOIN CMS_ACL ON CMS_ACL.ACLID = CMS_Tree.NodeACLID WHERE NodeSiteID = @SiteID AND NodeAliasPath LIKE @NodeAliasPath)
	OPEN @aclCursor
	FETCH NEXT FROM @aclCursor INTO @ACLInheritedACLs, @ACL;

	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @ACLInheritedACLs = REPLACE(',' + @ACLInheritedACLs + ',', ',' + @ACLID + ',', ',')
    		SET @InheritedACLsLength = LEN(@ACLInheritedACLs)
    		IF @InheritedACLsLength > 1
    		BEGIN
			SET @ACLInheritedACLs = SUBSTRING(@ACLInheritedACLs, 2,@InheritedACLsLength - 2)
    		END
    		ELSE
    		BEGIN
			SET @ACLInheritedACLs = ''
    		END
		UPDATE CMS_ACL SET ACLInheritedACLs = @ACLInheritedACLs WHERE ACLID = @ACL

		FETCH NEXT FROM @aclCursor INTO @ACLInheritedACLs, @ACL
	END

	CLOSE @aclCursor;
	DEALLOCATE @aclCursor;	
END
GO

-- Update particular query
UPDATE CMS_Query SET QueryText='Proc_CMS_ACL_RemoveACLID', QueryTypeID = 1 WHERE QueryName = 'removeaclid' AND ClassID = (SELECT ClassID FROM CMS_Class WHERE ClassName=N'CMS.ACL')
GO

-- Update settings key validation regex
UPDATE	[CMS_SettingsKey] SET [KeyValidation] = '\d+' WHERE [KeyName] = 'CMSLogSize' AND [SiteID] IS NULL
GO

-- Update webpart filename
UPDATE [CMS_WebPart] SET [WebPartFileName] = '/Community/Friends/FriendsDataSource.ascx' WHERE [WebPartFileName] = '/Community/FriendsDataSource.ascx'
GO

ALTER PROCEDURE [Proc_CMS_User_IsAuthorizedPerNode]
@UserID int, @NodeID int, @PermissionName nvarchar(100), @GenericRoles nvarchar(200), @SiteID int
AS
BEGIN
	DECLARE @SelectedUserID int;
	SELECT TOP 1 @SelectedUserID = CMS_User.UserID
	FROM CMS_User
	INNER JOIN CMS_UserRole on CMS_UserRole.UserID = cms_user.UserID
	INNER JOIN CMS_Role on CMS_Role.RoleID = CMS_UserRole.RoleID
	INNER JOIN CMS_RolePermission on CMS_RolePermission.RoleID = CMS_Role.RoleID
	INNER JOIN CMS_Permission on CMS_Permission.permissionid = CMS_RolePermission.PermissionID
	INNER JOIN CMS_Class on CMS_Class.ClassID = CMS_Permission.ClassID
	INNER JOIN CMS_Tree on CMS_Tree.NodeClassID = CMS_Class.ClassID
	WHERE CMS_Tree.NodeID = @NodeID
	and CMS_User.UserID = @UserID
	and CMS_Permission.PermissionName = @PermissionName
	and CMS_Role.SiteID = @SiteID
	-- Try to process special roles
	IF (@SelectedUserID IS NULL) OR (@SelectedUserID = 0)
	BEGIN
		DECLARE @SQL varchar(600)
		SET @SQL = 
		'SELECT TOP 1 CMS_Role.RoleID
		FROM CMS_Role
		INNER JOIN CMS_RolePermission on CMS_RolePermission.RoleID = CMS_Role.RoleID
		INNER JOIN CMS_Permission on CMS_Permission.permissionid = CMS_RolePermission.PermissionID
		INNER JOIN CMS_Class on CMS_Class.ClassID = CMS_Permission.ClassID
		INNER JOIN CMS_Tree on CMS_Tree.NodeClassID = CMS_Class.ClassID
		WHERE CMS_Tree.NodeID = ' + CAST(@NodeID AS nvarchar) + ' AND CMS_Permission.PermissionName =''' + @PermissionName + 
		''' AND CMS_Role.RoleName IN (' + @GenericRoles + ') AND CMS_Role.SiteID=' + CAST(@SiteID AS nvarchar)
		EXEC(@SQL)
	END
	ELSE
	SELECT @SelectedUserID
END
GO

-- Update deleting user dependencies
ALTER PROCEDURE [Proc_CMS_User_RemoveDependences]
    @ID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    BEGIN TRANSACTION;
    -- deletes dependencies in CMS_UserSite, CMS_UserRole and CMS_EmailUser
    DELETE FROM [CMS_UserSite] WHERE UserID=@ID;
    DELETE FROM [CMS_UserRole] WHERE UserID=@ID;
    DELETE FROM [CMS_EmailUser] WHERE UserID=@ID;
    -- delete dependencies in CMS_UserCulture
    DELETE FROM [CMS_UserCulture] WHERE UserID=@ID;
    -- delete dependencies in Forums_ForumModerators
    DELETE FROM [Forums_ForumModerators] WHERE UserID=@ID;
    -- delete dependencies in Forums_ForumSubscription
    DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionUserID=@ID;
    -- updates dependencies in CMS_EventLog, CMC_Document, CMS_VersionHistory and CMS_WorkflowHistory
    UPDATE [CMS_Document] SET DocumentCreatedByUserID=NULL WHERE DocumentCreatedByUserID=@ID;
    UPDATE [CMS_Document] SET DocumentCheckedOutByUserID=NULL WHERE DocumentCheckedOutByUserID=@ID;
    UPDATE [CMS_Document] SET DocumentModifiedByUserID=NULL WHERE DocumentModifiedByUserID=@ID;
    UPDATE [CMS_EventLog] SET UserID=NULL WHERE UserID=@ID
    UPDATE CMS_VersionHistory SET ModifiedByUserID=NULL WHERE ModifiedByUserID=@ID;
    UPDATE CMS_WorkflowHistory SET ApprovedByUserID=NULL WHERE ApprovedByUserID=@ID;
    -- remove dependencies in NodeOwner
    UPDATE [CMS_Tree] SET NodeOwner=NULL WHERE NodeOwner=@ID;
    -- remove dependencies in CMS_ACLItem
    DELETE FROM CMS_ACLItem WHERE UserID = @ID;
    UPDATE CMS_ACLItem SET LastModifiedByUserID=NULL WHERE LastModifiedByUserID=@ID;
    -- update dependencies in COM_Customer, COM_OrderStatusUser, COM_ShoppingCart
    UPDATE COM_Customer SET CustomerUserID=NULL WHERE CustomerUserID=@ID;
    UPDATE COM_OrderStatusUser SET ChangedByUserID=NULL WHERE ChangedByUserID=@ID;
    UPDATE COM_ShoppingCart SET ShoppingCartUserID=NULL WHERE ShoppingCartUserID=@ID;
    -- remove dependencies in COM_UserDepartment
    DELETE FROM COM_UserDepartment WHERE UserID=@ID;
    -- remove dependencies in [COM_Wishlist]
    DELETE FROM [COM_Wishlist] WHERE UserID=@ID;
    -- set null to media file FKs
    UPDATE Media_File SET FileCreatedByUserID=NULL WHERE FileCreatedByUserID=@ID;
    UPDATE Media_File SET FileModifiedByUserID=NULL WHERE FileModifiedByUserID=@ID;
    -- set null to saved reports
    UPDATE Reporting_SavedReport SET SavedReportCreatedByUserID = NULL WHERE SavedReportCreatedByUserID=@ID
    -- set null to checkouted templates, layouts and css styles
    UPDATE CMS_PageTemplate SET PageTemplateLayoutCheckedOutByUserID = NULL WHERE PageTemplateLayoutCheckedOutByUserID = @ID;
    UPDATE CMS_Layout SET LayoutCheckedOutByUserID = NULL WHERE LayoutCheckedOutByUserID=@ID;
    UPDATE CMS_CssStyleSheet SET StylesheetCheckedOutByUserID = NULL WHERE StylesheetCheckedOutByUserID=@ID;
    -- Blog_Comment - set CommentUserID a CommentApprovedByUserID to null
    UPDATE Blog_Comment SET CommentUserID = NULL WHERE CommentUserID=@ID;
    UPDATE Blog_Comment SET CommentApprovedByUserID = NULL WHERE CommentApprovedByUserID=@ID;
    UPDATE Blog_PostSubscription SET SubscriptionUserID = NULL WHERE SubscriptionUserID=@ID;
    -- Messaging_Message - set MessageSenderUserID to null and MessageSenderDeleted to true
    UPDATE Messaging_Message SET MessageSenderUserID = NULL, MessageSenderDeleted=1 WHERE MessageSenderUserID=@ID;
    UPDATE Messaging_Message SET MessageRecipientUserID = NULL, MessageRecipientDeleted=1 WHERE MessageRecipientUserID=@ID;
    DELETE FROM Messaging_Message WHERE MessageRecipientDeleted=1 AND MessageSenderDeleted=1;
    -- ForumsPost
    UPDATE Forums_ForumPost SET PostUserID = NULL WHERE PostUserID = @ID;
    UPDATE Forums_ForumPost SET PostApprovedByUserID = NULL WHERE PostApprovedByUserID = @ID;
    -- Forum user favorites
    DELETE FROM [Forums_UserFavorites] WHERE UserID = @ID;
    -- Export history
    UPDATE Export_History SET ExportUserID = NULL
    -- Groups
    UPDATE [Community_Group] SET GroupCreatedByUserID = NULL WHERE GroupCreatedByUserID = @ID;
    UPDATE [Community_Group] SET GroupApprovedByUserID = NULL WHERE GroupApprovedByUserID = @ID;
    DELETE FROM [Community_GroupMember] WHERE MemberUserID = @ID;
    UPDATE [Community_GroupMember] SET MemberApprovedByUserID = NULL WHERE MemberApprovedByUserID = @ID;
    UPDATE [Community_GroupMember] SET MemberInvitedByUserID = NULL WHERE MemberInvitedByUserID = @ID;
    -- Notifications
    DELETE FROM Notification_Subscription WHERE SubscriptionUserID = @ID;
    -- Message boards
    DELETE Board_Moderator WHERE UserID = @ID;
    UPDATE Board_Message SET MessageUserID = NULL WHERE MessageUserID = @ID;
    UPDATE Board_Message SET MessageApprovedByUserID = NULL WHERE MessageApprovedByUserID = @ID;
    DELETE Board_Moderator WHERE UserID = @ID;
    -- User message boards
    DELETE FROM Board_Message WHERE MessageBoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );
    DELETE FROM Board_Moderator WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );
    DELETE FROM Board_Role WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );        
	DELETE FROM Board_Subscription WHERE SubscriptionUserID = @ID; -- delete users subscriptions   
    DELETE FROM Board_Subscription WHERE SubscriptionBoardID IN (SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID); --delete subscriptions on users boards
    DELETE FROM Board_Board WHERE BoardUserID = @ID;
    -- Abuse report
    UPDATE CMS_AbuseReport SET ReportUserID = NULL WHERE ReportUserID = @ID;
    -- Contact list
    DELETE Messaging_ContactList WHERE ContactListUserID = @ID OR ContactListContactUserID = @ID;
    -- Ignore list
    DELETE Messaging_IgnoreList WHERE IgnoreListUserID = @ID OR IgnoreListIgnoredUserID = @ID;
    -- Friends
    DELETE Community_Friend WHERE FriendRequestedUserID = @ID OR FriendUserID = @ID OR FriendApprovedBy = @ID OR FriendRejectedBy = @ID;
    -- Categories
    DELETE CMS_DocumentCategory WHERE CategoryID IN ( SELECT CategoryID FROM CMS_Category WHERE CategoryUserID = @ID );
    DELETE CMS_Category WHERE CategoryUserID = @ID;
    -- Delete user sessions
    DELETE FROM CMS_Session WHERE SessionUserID = @ID;
    -- Invitations
    DELETE FROM [Community_Invitation] WHERE InvitedUserID = @ID OR InvitedByUserID = @ID;
    -- Activated by user id
    UPDATE [CMS_UserSettings] SET UserActivatedByUserID = NULL WHERE UserActivatedByUserID = @ID;
    --Widgets
    DELETE FROM CMS_Personalization WHERE PersonalizationUserID = @ID;
    --OpenIDUser
    DELETE FROM CMS_OpenIDUser WHERE UserID = @ID;
    --Newsletters
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE [SubscriberID] IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID);
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID);
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID;
    
    COMMIT TRANSACTION;
END
GO


-- Update deleting role dependencies
ALTER PROCEDURE [Proc_CMS_Role_RemoveDependences]
    @RoleID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    
    BEGIN TRANSACTION;
    
    DELETE FROM CMS_UserRole WHERE RoleID=@RoleID;
    DELETE FROM CMS_RolePermission WHERE RoleID=@RoleID; 
    DELETE FROM CMS_ACLItem WHERE RoleID=@RoleID;
    DELETE FROM CMS_WorkflowStepRoles WHERE RoleID=@RoleID; 
    DELETE FROM Forums_ForumRoles WHERE RoleID = @RoleID;
    DELETE FROM Polls_PollRoles WHERE RoleID = @RoleID;
    DELETE FROM Media_LibraryRolePermission WHERE RoleID = @RoleID;
    DELETE FROM Community_GroupRolePermission WHERE RoleID = @RoleID;
    DELETE FROM CMS_WidgetRole WHERE RoleID = @RoleID;
    -- Message boards
    DELETE FROM Board_Role WHERE RoleID = @RoleID;
    -- UIProfiles
    DELETE FROM CMS_RoleUIElement WHERE RoleID = @RoleID;
    --Newsletters
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE [SubscriberID] IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID);
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID);
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID;
    
    COMMIT TRANSACTION;
END
GO


-- Remove invalid dependencies for users
BEGIN
DECLARE @subscribers TABLE ( ID int not null ) 
	INSERT INTO @subscribers 
		SELECT SubscriberID FROM Newsletter_Subscriber 
		WHERE SubscriberType LIKE 'cms.user' 
		AND SubscriberRelatedID NOT IN (SELECT UserID FROM CMS_User)
							
	BEGIN TRANSACTION
		DELETE FROM [Newsletter_SubscriberNewsletter] WHERE [SubscriberID] IN (SELECT ID FROM @subscribers);
		DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (SELECT ID FROM @subscribers);
		DELETE FROM [Newsletter_Subscriber] WHERE SubscriberID IN (SELECT ID FROM @subscribers);
	COMMIT TRANSACTION;	
DELETE FROM @subscribers;
END
GO

-- Remove invalid dependencies for roles
BEGIN
DECLARE @subscribers TABLE ( ID int not null ) 
	INSERT INTO @subscribers 
		SELECT SubscriberID FROM Newsletter_Subscriber 
		WHERE SubscriberType LIKE 'cms.role' 
		AND SubscriberRelatedID NOT IN (SELECT RoleID FROM CMS_Role)
			
	BEGIN TRANSACTION
		DELETE FROM [Newsletter_SubscriberNewsletter] WHERE [SubscriberID] IN (SELECT ID FROM @subscribers);
		DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (SELECT ID FROM @subscribers);
		DELETE FROM [Newsletter_Subscriber] WHERE SubscriberID IN (SELECT ID FROM @subscribers);
	COMMIT TRANSACTION;	
DELETE FROM @subscribers;
END
GO

/* Drop old unique index for polls */
IF  EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[Polls_Poll]') AND name = N'IX_Polls_Poll_PollSiteID_PollCodeName')
DROP INDEX [IX_Polls_Poll_PollSiteID_PollCodeName] ON [Polls_Poll] WITH ( ONLINE = OFF )
GO

/* Create new non-unique index for polls */
CREATE NONCLUSTERED INDEX [IX_Polls_Poll_PollSiteID_PollCodeName] ON [Polls_Poll] 
(
	[PollSiteID] ASC,
	[PollCodeName] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON, FILLFACTOR = 80) ON [PRIMARY]
GO

/* Update webpart properties */
UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><category name="Feed link" /><field column="LinkText" fieldcaption="Link text" visible="true" defaultvalue="RSS 2.0" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="false" guid="a526fda9-647b-4edd-8947-f288965a9d2d" visibility="none" ismacro="false" fielddescription="Text for the feed link." /><field column="LinkIcon" fieldcaption="Link icon" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="2000" publicfield="false" spellcheck="false" guid="2495bd2a-71c5-4599-a15a-d05ddd6dc620" visibility="none" ismacro="false" fielddescription="Icon which will be displayed in the feed link."><settings><controlname>iconselector</controlname></settings></field><field column="EnableRSSAutodiscovery" fieldcaption="Enable RSS auto-discovery" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="false" guid="2d9639d7-ce1f-4be7-8ac3-3a9eb420d8e0" visibility="none" ismacro="false" fielddescription="Indicates if the RSS feed is automatically discovered by the browser." /><category name="RSS" /><field column="FeedName" fieldcaption="Feed name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="false" guid="7dd88605-7f7c-49c1-b420-612c34280d96" visibility="none" ismacro="false" fielddescription="Feed name to identify this feed on a page with multiple feeds. If the value is empty the GUID of the web part instance will be used by default." /><field column="FeedTitle" fieldcaption="Feed title" visible="true" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="false" guid="02ea6032-e5bc-4ad6-b171-8cf3700bb520" visibility="none" ismacro="false" fielddescription="URL title of the feed." columnsize="450" defaultvalue="Blog comments" /><field column="FeedDescription" fieldcaption="Feed description" visible="true" columntype="longtext" fieldtype="textarea" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="false" guid="b93c4faa-d7da-4223-a70d-757cf944403f" visibility="none" ismacro="false" fielddescription="Description of the feed." /><field column="FeedLanguage" fieldcaption="Feed language" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="Language of the feed. If the value is empty the content culture will be used." publicfield="false" spellcheck="false" guid="a48b6d99-ac6e-4e6f-937a-edf17ece7f74" visibility="none" ismacro="false"><settings><controlname>selectculture</controlname></settings></field><field column="QueryStringKey" fieldcaption="Feed querystring key" visible="true" defaultvalue="rss" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" publicfield="false" spellcheck="false" guid="b7939bd3-7e28-4b97-929f-fddada90da0c" visibility="none" ismacro="false" fielddescription="Querystring key which is used for RSS feed identification on a page with multiple RSS feeds." /><field column="HeaderXML" fieldcaption="Feed header" visible="true" columntype="longtext" fieldtype="textarea" allowempty="true" isPK="false" system="false" publicfield="false" spellcheck="false" guid="31e9b748-1e3f-4ec7-b00e-2d199be7ae4b" visibility="none" ismacro="false" fielddescription="Custom feed header XML which is generated before feed items. If the value is empty default header for RSS feed is generated." /><field column="FooterXML" fieldcaption="Feed footer" visible="true" columntype="longtext" fieldtype="textarea" allowempty="true" isPK="false" system="false" fielddescription="Custom feed footer XML which is generated after feed items. If the value is empty default footer for RSS feed is generated." publicfield="false" spellcheck="false" guid="3dcf3694-6a69-4931-8e99-bb497354ec5d" visibility="none" ismacro="false" /><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="false" isPK="false" system="false" columnsize="250" fielddescription="{$documentation.webpartproperties.transformationfeed$}" publicfield="false" spellcheck="true" guid="e6c86dd8-a1ac-4782-841b-2dc263b6bdd9" defaultvalue="CMS.RSSTransformations.BlogComments" visibility="none" ismacro="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="F" caption="Comments filter" /><field column="SelectOnlyApproved" fieldcaption="Select only approved" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.selectonlyapproved$}" publicfield="false" spellcheck="true" guid="0526cbee-debe-4bff-849b-f62b8f02b824" visibility="none" ismacro="false" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="{$documentation.webpartproperties.orderby$}" publicfield="false" spellcheck="true" guid="643dee71-7339-4a60-a7ea-3f1cb3d72151" visibility="none" ismacro="false" defaultvalue="CommentDate DESC" /><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" fielddescription="Selects only top N items. If blank, all items are selected." publicfield="false" spellcheck="true" guid="8c859b6f-5eaa-47e3-a905-8da5a6ccba7d" visibility="none" ismacro="false" /><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="{$documentation.webpartproperties.sitename$}" publicfield="false" spellcheck="true" guid="11b04f5c-b17f-4150-96aa-4a4f1047f2b6" visibility="none" ismacro="false"><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="Where condition for blog comments." publicfield="false" spellcheck="true" guid="bf340f2c-5217-47e9-8a9a-4c2fc9a4110c" visibility="none" ismacro="false" /><field column="SelectedColumns" fieldcaption="Columns" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="{$documentation.webpartproperties.columns$}" publicfield="false" spellcheck="true" guid="669d41ce-d717-452d-a79c-4d9c7b0c3a7b" visibility="none" ismacro="false" /><category name="Filter" caption="Document filter" /><field column="UseDocumentFilter" fieldcaption="Use document filter" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" fielddescription="Indicates if the comments should be retrieved according to document filter settings." publicfield="false" spellcheck="true" guid="572262cf-e67c-4e2d-a25e-411698d80d1b" visibility="none" ismacro="false" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="450" publicfield="false" spellcheck="true" guid="d1dc26d0-211a-4e15-b652-242a23b38f62" visibility="none" ismacro="false" fielddescription="Path of the documents."><settings><controlname>selectpath</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" isPK="false" system="false" columnsize="5" publicfield="false" spellcheck="true" guid="0839ea6e-ff4b-4cd7-a012-887e39f26786" visibility="none" ismacro="false" fielddescription="Indicates if default language version of the document should be used during filtering if the document is not translated to the current language."><settings><repeatdirection>vertical</repeatdirection><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="20" fielddescription="Culture version of the documents." publicfield="false" spellcheck="true" guid="564ab35e-3658-4b97-be89-e823af4e1551" visibility="none" ismacro="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" fielddescription="Maximum nesting level. It specifies the number of sub-levels in the content tree that should be included in the filtered content." publicfield="false" spellcheck="true" guid="90572295-3e55-495b-aee1-533fc1473b7c" visibility="none" ismacro="false" /><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" fielddescription="Indicates if only published documents should be used during filtering." publicfield="false" spellcheck="true" guid="0c341d80-c3b9-4ddb-a020-b4c2d58038a2" visibility="none" ismacro="false" /><field column="DocumentsWhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="{$documentation.webpartproperties.where$}" publicfield="false" spellcheck="true" guid="a1fb320f-c3d3-4f81-ab88-906e013300d4" visibility="none" ismacro="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="{$documentation.webpartproperties.cacheitemname$}" publicfield="false" spellcheck="false" guid="fe788261-44b1-4896-944a-9c2e3961c2a9" visibility="none" ismacro="false" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.cacheminutes$}" publicfield="false" spellcheck="false" guid="6b6bded8-4f40-4b2d-86da-9727870851c5" visibility="none" ismacro="false" /><field column="CacheDependencies" fieldcaption="Cache dependencies" visible="true" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.cachedependencies$}" publicfield="false" spellcheck="false" guid="49858114-49e4-4794-b241-20eca9d41362" visibility="none" ismacro="false"><settings><controlname>cachedependencies</controlname></settings></field></form>' WHERE [WebPartName] = N'BlogCommentsRSSFeed'
GO


-- Drop newsletter.issue.unsubscribe stored procedure if exists
IF (SELECT TOP 1 Name FROM SysObjects WHERE Type = 'P' and Name='Proc_Newsletter_Issue_Unsubscribe') IS NOT NULL
BEGIN
	DROP PROCEDURE [Proc_Newsletter_Issue_Unsubscribe]
END
GO

-- Create newsletter.issue.unsubscribe stored procedure anew
CREATE PROCEDURE [Proc_Newsletter_Issue_Unsubscribe]	
	@IssueID int
AS
BEGIN
	SET NOCOUNT ON;
	
	BEGIN TRANSACTION
	
	DECLARE @Unsubscribed AS INT
	SET @Unsubscribed = (SELECT IssueUnsubscribed FROM [Newsletter_NewsletterIssue] WHERE IssueID = @IssueID)	
	SET @Unsubscribed = @Unsubscribed + 1
	UPDATE Newsletter_NewsletterIssue SET IssueUnsubscribed = @Unsubscribed WHERE IssueID = @IssueID			
		
	COMMIT TRANSACTION    
END
GO

-- Register newsletter.issue.unsubscribe query
DECLARE @IssueClassID AS INT
SET @IssueClassID = (SELECT TOP 1 [ClassID] FROM [CMS_Class] WHERE [ClassName] = 'newsletter.issue')

IF  (SELECT TOP 1 QueryName FROM [CMS_Query] WHERE ClassID = @IssueClassID AND QueryName LIKE 'unsubscribe') IS NOT NULL
BEGIN
	DELETE FROM [CMS_Query] WHERE ClassID = @IssueClassID AND QueryName LIKE 'unsubscribe' 
END

INSERT INTO [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked], [QueryLastModified], [QueryGUID], [QueryLoadGeneration], [QueryIsCustom])
	VALUES ('unsubscribe', 1, 'Proc_Newsletter_Issue_Unsubscribe', 0, @IssueClassID, 1, CURRENT_TIMESTAMP, '36820183-B3BB-4DB6-8D99-FF8FADBE8347', 2, 1) 
GO


-- Drop newsletter.issue.addsentemail stored procedure if exists
IF (SELECT TOP 1 Name FROM SysObjects WHERE Type = 'P' and Name='Proc_Newsletter_Issue_AddSentEmails') IS NOT NULL
BEGIN
	DROP PROCEDURE [Proc_Newsletter_Issue_AddSentEmails]
END
GO

-- Create newsletter.issue.addsentemail stored procedure anew
CREATE PROCEDURE [Proc_Newsletter_Issue_AddSentEmails]
	@IssueID INT,
	@Emails INT,
	@MailoutTime DATETIME
AS
BEGIN
	SET NOCOUNT ON;
	
	BEGIN TRANSACTION
	
	DECLARE @SentEmails AS INT
	SET @SentEmails = (SELECT IssueSentEmails FROM [Newsletter_NewsletterIssue] WHERE IssueID = @IssueID)
	SET @SentEmails = @SentEmails + @Emails;
	UPDATE [Newsletter_NewsletterIssue] SET IssueSentEmails = @SentEmails, IssueMailoutTime = @MailoutTime WHERE IssueID = @IssueID		
	
	COMMIT TRANSACTION    
END
GO

-- Register newsletter.issue.addsentemails query
DECLARE @IssueClassID AS INT
SET @IssueClassID = (SELECT TOP 1 [ClassID] FROM [CMS_Class] WHERE [ClassName] = 'newsletter.issue')

IF  (SELECT TOP 1 QueryName FROM [CMS_Query] WHERE ClassID = @IssueClassID AND QueryName LIKE 'addsentemails') IS NOT NULL
BEGIN
	DELETE FROM [CMS_Query] WHERE ClassID = @IssueClassID AND QueryName LIKE 'addsentemails' 
END

INSERT INTO [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked], [QueryLastModified], [QueryGUID], [QueryLoadGeneration], [QueryIsCustom])
	VALUES ('addsentemails', 1, 'Proc_Newsletter_Issue_AddSentEmails', 0, @IssueClassID, 1, CURRENT_TIMESTAMP, '61118D4E-27C5-41F0-A177-9C1B546D7FF2', 2, 1) 

GO


-- Correct webpart path 
DECLARE @webpartid int
SET @webpartid = (SELECT TOP 1 WebPartID FROM CMS_WebPart WHERE WebPartName = N'GroupsDataSource' AND WebPartFileName = N'/Community/GroupsDataSource.ascx')

IF @webpartid > 0 BEGIN
	UPDATE CMS_WebPart SET WebPartFileName = N'/Community/Groups/GroupsDataSource.ascx' WHERE WebPartID = @webpartid
END
GO


-- Correct group members datasource webpart path 
DECLARE @webpartid int
SET @webpartid = (SELECT TOP 1 WebPartID FROM CMS_WebPart WHERE WebPartName = N'GroupMembersDataSource' AND WebPartFileName = N'/Community/GroupMembersDataSource.ascx')

IF @webpartid > 0 BEGIN
	UPDATE CMS_WebPart SET WebPartFileName = N'/Community/Members/GroupMembersDataSource.ascx' WHERE WebPartID = @webpartid
END
GO

-- Alter versionhistory.dropdependences stored procedure anew
ALTER PROCEDURE [Proc_CMS_VersionHistory_RemoveDependences]
	@VersionHistoryID INT
AS
BEGIN
	SET NOCOUNT ON;
	
	/* Update the documents */
	UPDATE CMS_Document SET DocumentCheckedOutVersionHistoryID = NULL, DocumentCheckedOutByUserID = NULL, DocumentCheckedOutWhen = NULL WHERE DocumentCheckedOutVersionHistoryID = @VersionHistoryID; 
	UPDATE CMS_Document SET DocumentPublishedVersionHistoryID = NULL WHERE DocumentPublishedVersionHistoryID = @VersionHistoryID; 
	
	/* Clear the workflow history */
	DELETE FROM CMS_WorkflowHistory WHERE VersionHistoryID = @VersionHistoryID; 
	
	/* Clear the attachment history - delete all the attachments that are connected to */  
	DELETE FROM CMS_AttachmentHistory WHERE AttachmentHistoryID IN (SELECT AttachmentHistoryID FROM CMS_VersionAttachment WITH (NOLOCK) WHERE VersionHistoryID = @VersionHistoryID GROUP BY AttachmentHistoryID HAVING COUNT(VersionHistoryID) <= 1)
END
GO

/* Hotfix version lower than 5.5.14 */
IF (ISNULL(Cast((SELECT KeyValue FROM [CMS_SettingsKey] WHERE KeyName = N'CMSHotfixVersion') as nvarchar(50)), 0) < 14) 
BEGIN

/* Update cms.eventlog.deleteolderlogs query */
UPDATE CMS_Query SET QueryText = 'DELETE FROM [CMS_EventLog] WHERE ([EventID] NOT IN (SELECT ##TOPN## [EventID] FROM [CMS_EventLog] WITH (NOLOCK) WHERE ##WHERE## ORDER BY ##ORDERBY##)) AND (##WHERE##)' WHERE QueryName LIKE N'deleteolderlogs' AND ClassID = (SELECT ClassID FROM CMS_Class WHERE ClassName=N'CMS.Eventlog')

END
GO

/* Hotfix version lower than 5.5.14 */
IF (ISNULL(Cast((SELECT KeyValue FROM [CMS_SettingsKey] WHERE KeyName = N'CMSHotfixVersion') as nvarchar(50)), 0) < 14) 
BEGIN

/* Repairs problem with underscore in wildcard URLs */
UPDATE CMS_Document SET DocumentWildcardRule = REPLACE(DocumentWildcardRule, N'_', N'[_]') WHERE DocumentWildcardRule LIKE N'%[_]%' AND DocumentWildcardRule NOT LIKE N'%[[][_]]%'
UPDATE CMS_DocumentAlias SET AliasWildcardRule = REPLACE(AliasWildcardRule, N'_', N'[_]') WHERE AliasWildcardRule LIKE N'%[_]%' AND AliasWildcardRule NOT LIKE N'%[[][_]]%'

END
GO

/* Hotfix version lower than 5.5.14 */
IF (ISNULL(Cast((SELECT KeyValue FROM [CMS_SettingsKey] WHERE KeyName = N'CMSHotfixVersion') as nvarchar(50)), 0) < 14) 
BEGIN

/* Add new property to Mobil redirection webpart */
UPDATE CMS_WebPart SET WebPartProperties = '<form><category name="Redirection settings" /><field column="RedirectionURL" fieldcaption="Redirection URL" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="1000" fielddescription="URL to which the mobile device should be redirected." publicfield="false" spellcheck="false" guid="f0a298d3-9e73-4191-8f3c-12c028fb950a" visibility="none" ismacro="false" /><field column="AlwaysRedirect" fieldcaption="Always redirect" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" fielddescription="Indicates if redirection will be done even if redirection cookie is present." publicfield="false" spellcheck="false" guid="d847aeac-8c4f-4af9-a718-732bd785b0b3" visibility="none" ismacro="false" /></form>'
WHERE WebPartName = N'MobileDeviceRedirection'

END
GO

IF (ISNULL(Cast((SELECT KeyValue FROM [CMS_SettingsKey] WHERE KeyName = N'CMSHotfixVersion') as nvarchar(50)), 0) < 17) 
BEGIN

/* New queries for recycle bin */
UPDATE CMS_Query SET QueryText = 'SELECT ##TOPN## ##COLUMNS## FROM CMS_VersionHistory  LEFT OUTER JOIN CMS_Document on CMS_VersionHistory.DocumentID = CMS_Document.DocumentID  WHERE CMS_Document.DocumentID IS NULL  AND (NodeSiteID=@SiteID OR NodeSiteID IS NULL OR @SiteID = 0)  AND (VersionHistoryID = (SELECT MAX(VersionHistoryID) FROM CMS_VersionHistory vh WITH(NOLOCK) WHERE vh.DocumentID = CMS_VersionHistory.DocumentID))  AND ##WHERE##  ORDER BY ##ORDERBY##'
WHERE QueryName = N'selectallrecyclebin'

UPDATE CMS_Query SET QueryText = 'SELECT ##TOPN## ##COLUMNS## FROM CMS_VersionHistory  LEFT OUTER JOIN CMS_Document on CMS_VersionHistory.DocumentID = CMS_Document.DocumentID  WHERE CMS_Document.DocumentID IS NULL AND ModifiedByUserID = @UserID  AND (NodeSiteID=@SiteID OR NodeSiteID IS NULL)  AND (VersionHistoryID = (SELECT MAX(VersionHistoryID) FROM CMS_VersionHistory vh WITH(NOLOCK) WHERE vh.DocumentID = CMS_VersionHistory.DocumentID))  AND ##WHERE##  ORDER BY ##ORDERBY##'
WHERE QueryName = N'selectmyrecyclebin'


END
GO

/* Hotfix version lower than 5.5.23 */
IF (ISNULL(Cast((SELECT KeyValue FROM [CMS_SettingsKey] WHERE KeyName = N'CMSHotfixVersion') as nvarchar(50)), 0) < 23) 
BEGIN

/* Fixes "ORDER BY" clause in webanalytics queries */
UPDATE Reporting_ReportTable SET TableQuery = 'SELECT TOP 100   CASE WHEN DocumentNamePath LIKE '''' OR DocumentNamePath IS NULL THEN StatisticsObjectName ELSE DocumentNamePath END AS ''{$reports_pageviews_day.path_header$}'',   SUM(HitsCount) AS ''{$reports_pageviews_day.hits_header$}''   FROM   Analytics_Statistics  INNER JOIN Analytics_DayHits ON Analytics_DayHits.HitsStatisticsID =  Analytics_Statistics.StatisticsID  LEFT JOIN View_CMS_Tree_Joined ON View_CMS_Tree_Joined.NodeID =  Analytics_Statistics.StatisticsObjectID AND  Analytics_Statistics.StatisticsObjectCulture =  View_CMS_Tree_Joined.DocumentCulture  WHERE (StatisticsSiteID = @CMSContextCurrentSiteID)   AND (StatisticsCode=@CodeName)   AND (HitsStartTime >= @FromDate)   AND (HitsEndTime <= @ToDate)   GROUP BY DocumentNamePath,  StatisticsObjectName  ORDER BY [{$reports_pageviews_day.hits_header$}] DESC'
WHERE TableID = (SELECT TableID FROM Reporting_Report, Reporting_ReportCategory, Reporting_ReportTable WHERE
Tablename='TableDayPageViews' AND CategoryCodeName='WebAnalytics' AND ReportName='pageviews.dayreport')

UPDATE Reporting_ReportTable SET TableQuery = 'SELECT TOP 100   CASE   WHEN DocumentNamePath LIKE '''' OR DocumentNamePath IS NULL THEN StatisticsObjectName  ELSE DocumentNamePath   END AS ''{$reports_pageviews_month.path_header$}'',   SUM(HitsCount) AS ''{$reports_pageviews_month.hits_header$}''   FROM Analytics_Statistics  INNER JOIN Analytics_MonthHits ON Analytics_MonthHits.HitsStatisticsID = Analytics_Statistics.StatisticsID   LEFT JOIN View_CMS_Tree_Joined ON Analytics_Statistics.StatisticsObjectID = View_CMS_Tree_Joined.NodeID AND Analytics_Statistics.StatisticsObjectCulture=View_CMS_Tree_Joined.DocumentCulture   WHERE (StatisticsSiteID = @CMSContextCurrentSiteID) AND (HitsStartTime >= @FromDate) AND (HitsEndTime <= @ToDate)  AND (StatisticsCode=@CodeName)   GROUP BY DocumentNamePath, StatisticsObjectName  ORDER BY [{$reports_pageviews_month.hits_header$}] DESC'
WHERE TableID = (SELECT TableID FROM Reporting_Report, Reporting_ReportCategory, Reporting_ReportTable WHERE
Tablename='TableMonthPageViews' AND CategoryCodeName='WebAnalytics' AND ReportName='pageviews.monthreport')

UPDATE Reporting_ReportTable SET TableQuery = 'SELECT TOP 100  CASE WHEN DocumentNamePath LIKE '''' OR DocumentNamePath IS NULL THEN StatisticsObjectName ELSE DocumentNamePath END AS ''{$reports_pageviews_hour.path_header$}'',  SUM(HitsCount) AS ''{$reports_pageviews_hour.hits_header$}''  FROM  Analytics_Statistics  INNER JOIN Analytics_HourHits ON Analytics_HourHits.HitsStatisticsID = Analytics_Statistics.StatisticsID  LEFT JOIN View_CMS_Tree_Joined ON View_CMS_Tree_Joined.NodeID = Analytics_Statistics.StatisticsObjectID AND Analytics_Statistics.StatisticsObjectCulture = View_CMS_Tree_Joined.DocumentCulture  WHERE (StatisticsSiteID = @CMSContextCurrentSiteID)  AND (StatisticsCode=@CodeName)  AND (HitsStartTime >= @FromDate)  AND (HitsEndTime <= @ToDate)  GROUP BY DocumentNamePath, StatisticsObjectName  ORDER BY [{$reports_pageviews_hour.hits_header$}] DESC'
WHERE TableID = (SELECT TableID FROM Reporting_Report, Reporting_ReportCategory, Reporting_ReportTable WHERE
Tablename='TableHourPageViews' AND CategoryCodeName='WebAnalytics' AND ReportName='pageviews.hourreport')

UPDATE Reporting_ReportTable SET TableQuery = 'SELECT TOP 100  CASE WHEN DocumentNamePath LIKE '''' OR DocumentNamePath IS NULL THEN StatisticsObjectName ELSE DocumentNamePath END AS ''{$reports_aggviews_hour.path_header$}'',  SUM(HitsCount) AS ''{$reports_aggviews_hour.hits_header$}''  FROM  Analytics_Statistics  INNER JOIN Analytics_HourHits ON Analytics_HourHits.HitsStatisticsID = Analytics_Statistics.StatisticsID  LEFT JOIN View_CMS_Tree_Joined ON View_CMS_Tree_Joined.NodeID = Analytics_Statistics.StatisticsObjectID AND Analytics_Statistics.StatisticsObjectCulture = View_CMS_Tree_Joined.DocumentCulture  WHERE (StatisticsSiteID = @CMSContextCurrentSiteID)  AND (StatisticsCode=@CodeName)  AND (HitsStartTime >= @FromDate)  AND (HitsEndTime <= @ToDate)  GROUP BY DocumentNamePath, StatisticsObjectName  ORDER BY [{$reports_aggviews_hour.hits_header$}] DESC'
WHERE TableID = (SELECT TableID FROM Reporting_Report, Reporting_ReportCategory, Reporting_ReportTable WHERE
Tablename='TableHourAggViews' AND CategoryCodeName='WebAnalytics' AND ReportName='aggviews.hourreport')

UPDATE Reporting_ReportTable SET TableQuery = 'SELECT TOP 100   CASE WHEN DocumentNamePath LIKE '''' OR DocumentNamePath IS NULL THEN StatisticsObjectName ELSE DocumentNamePath END AS ''{$reports_aggviews_day.path_header$}'',   SUM(HitsCount) AS ''{$reports_aggviews_day.hits_header$}''   FROM   Analytics_Statistics  INNER JOIN Analytics_DayHits ON Analytics_DayHits.HitsStatisticsID =  Analytics_Statistics.StatisticsID  LEFT JOIN View_CMS_Tree_Joined ON View_CMS_Tree_Joined.NodeID =  Analytics_Statistics.StatisticsObjectID AND  Analytics_Statistics.StatisticsObjectCulture =  View_CMS_Tree_Joined.DocumentCulture  WHERE (StatisticsSiteID = @CMSContextCurrentSiteID)   AND (StatisticsCode=@CodeName)   AND (HitsStartTime >= @FromDate)   AND (HitsEndTime <= @ToDate)   GROUP BY DocumentNamePath,  StatisticsObjectName  ORDER BY [{$reports_aggviews_day.hits_header$}] DESC'
WHERE TableID = (SELECT TableID FROM Reporting_Report, Reporting_ReportCategory, Reporting_ReportTable WHERE
Tablename='TableDayAggViews' AND CategoryCodeName='WebAnalytics' AND ReportName='aggviews.dayreport')

UPDATE Reporting_ReportTable SET TableQuery = 'SELECT TOP 100   CASE   WHEN DocumentNamePath LIKE '''' OR DocumentNamePath IS NULL THEN StatisticsObjectName  ELSE DocumentNamePath   END AS ''{$reports_aggviews_month.path_header$}'',   SUM(HitsCount) AS ''{$reports_aggviews_month.hits_header$}''   FROM Analytics_Statistics  INNER JOIN Analytics_MonthHits ON Analytics_MonthHits.HitsStatisticsID = Analytics_Statistics.StatisticsID   LEFT JOIN View_CMS_Tree_Joined ON Analytics_Statistics.StatisticsObjectID = View_CMS_Tree_Joined.NodeID AND Analytics_Statistics.StatisticsObjectCulture=View_CMS_Tree_Joined.DocumentCulture   WHERE (StatisticsSiteID = @CMSContextCurrentSiteID) AND (HitsStartTime >= @FromDate) AND (HitsEndTime <= @ToDate)  AND (StatisticsCode=@CodeName)   GROUP BY DocumentNamePath, StatisticsObjectName  ORDER BY [{$reports_aggviews_month.hits_header$}] DESC'
WHERE TableID = (SELECT TableID FROM Reporting_Report, Reporting_ReportCategory, Reporting_ReportTable WHERE
Tablename='TableMonthAggViews' AND CategoryCodeName='WebAnalytics' AND ReportName='aggviews.monthreport')

END
GO


/* ----------------------------------------------------------------------------*/
/* This SQL command must be at the end and must contain current hotfix version */
/* ----------------------------------------------------------------------------*/
UPDATE [CMS_SettingsKey] SET KeyValue = '24' WHERE KeyName = N'CMSHotfixVersion'
GO

